%define _buildid .4

Name:           kbd
Version:        1.15
Release: 11%{?_buildid}%{?dist}
Summary:        Tools for configuring the console (keyboard, virtual terminals, etc.)

Group:          System Environment/Base
License:        GPLv2+
URL:            http://ftp.altlinux.org/pub/people/legion/kbd
Source0:        http://ftp.altlinux.org/pub/people/legion/kbd/kbd-%{version}.tar.gz
Source1:        kbd-latsun-fonts.tar.bz2
Source2:        ro_maps.tar.bz2
Source3:        kbd-latarcyrheb-16-fixed.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Patch0:         kbd-1.15-po.patch
Patch1:         kbd-1.15-keycodes-man.patch
Patch2:         kbd-1.15-sparc.patch
Patch3:         kbd-1.15-unicode_start.patch
Patch4:         kbd-1.15-resizecon-x86_64.patch
Patch5:         kbd-1.15-quiet_doc.patch
Patch6:         kbd-1.15-defkeymap.patch

BuildRequires:  bison, flex, gettext
Conflicts:      util-linux < 2.11r-9
Requires:       initscripts >= 5.86-1
Requires:       %{name}-misc = %{version}-%{release}
BuildRequires:  glibc-static

%description
The %{name} package contains tools for managing a Linux
system's console's behavior, including the keyboard, the screen
fonts, the virtual terminals and font files.

%package misc
Summary:        Data for kbd package
BuildArch:      noarch

%description misc
The %{name}-misc package contains data for kbd package - console fonts,
keymaps etc. Please note that %{name}-misc is not helpful without kbd.

%prep
%setup -q -a 1 -a 2 -a 3
%patch0 -p1 -b .po
%patch1 -p1 -b .keycodes-man
%patch2 -p1 -b .sparc
%patch3 -p1 -b .unicode_start
%patch4 -p1 -b .resizecon_x86_64
%patch5 -p1 -b .quiet_doc
%patch6 -p1 -b .defkeymap

# 7-bit maps are obsolete; so are non-euro maps
pushd data/keymaps/i386
mv qwerty/fi.map qwerty/fi-old.map
cp qwerty/fi-latin9.map qwerty/fi.map
cp qwerty/pt-latin9.map qwerty/pt.map
cp qwerty/sv-latin1.map qwerty/se-latin1.map

mv azerty/fr.map azerty/fr-old.map
cp azerty/fr-latin9.map azerty/fr.map

cp azerty/fr-latin9.map azerty/fr-latin0.map # legacy alias

# Rename conflicting keymaps
mv dvorak/no.map dvorak/no-dvorak.map
mv fgGIod/trf.map fgGIod/trf-fgGIod.map
mv olpc/es.map olpc/es-olpc.map
mv olpc/pt.map olpc/pt-olpc.map
mv qwerty/cz.map qwerty/cz-qwerty.map
popd

# Convert to utf-8
iconv -f iso-8859-1 -t utf-8 < "ChangeLog" > "ChangeLog_"
mv "ChangeLog_" "ChangeLog"

%build
%configure --prefix=%{_prefix} --datadir=/lib/kbd --mandir=%{_mandir} --localedir=%{_datadir}/locale --enable-nls
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# ro_win.map.gz is useless
rm -f $RPM_BUILD_ROOT/lib/kbd/keymaps/i386/qwerty/ro_win.map.gz

# Create additional name for Serbian latin keyboard
ln -s sr-cy.map.gz $RPM_BUILD_ROOT/lib/kbd/keymaps/i386/qwerty/sr-latin.map.gz

# The rhpl keyboard layout table is indexed by kbd layout names, so we need a
# Korean keyboard
ln -s us.map.gz $RPM_BUILD_ROOT/lib/kbd/keymaps/i386/qwerty/ko.map.gz

# Move binaries which we use before /usr is mounted from %{_bindir} to /bin.
mkdir -p $RPM_BUILD_ROOT/bin
for binary in setfont dumpkeys kbd_mode unicode_start unicode_stop loadkeys ; do
  mv $RPM_BUILD_ROOT%{_bindir}/$binary $RPM_BUILD_ROOT/bin/
done

# Some microoptimization
sed -i -e 's,\<kbd_mode\>,/bin/kbd_mode,g;s,\<setfont\>,/bin/setfont,g' \
        $RPM_BUILD_ROOT/bin/unicode_start

# Link open to openvt
ln -s openvt $RPM_BUILD_ROOT%{_bindir}/open

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%files -f %{name}.lang
%defattr(-,root,root,-)
%doc ChangeLog AUTHORS README COPYING doc/kbd.FAQ*.html doc/font-formats/*.html doc/utf/utf* doc/dvorak/*
/bin/*
%{_bindir}/*
%{_mandir}/*/*

%files misc
%defattr(-,root,root,-)
/lib/kbd

%changelog
* Sat Feb 19 2011 01:48:01 UTC Cristian Gafton <gafton@amazon.com>
- build requires glibc-static

* Thu Dec 2 2010 02:08:16 UTC Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/kbd-1.15-11.el6

* Fri Jul 9 2010 22:07:42 UTC Cristian Gafton <gafton@amazon.com>
- import source package RHEL6/kbd-1.15-9.1.el6

* Fri May 7 2010 01:31:41 UTC Cristian Gafton <gafton@amazon.com>
- import source package RHEL5/kbd-1.12-21.el5

* Fri May 7 2010 01:31:40 UTC Cristian Gafton <gafton@amazon.com>
- import source package RHEL5/kbd-1.12-20.el5

* Fri May 7 2010 01:31:39 UTC Cristian Gafton <gafton@amazon.com>
- import source package RHEL5/kbd-1.12-19.el5

* Fri May 7 2010 00:13:54 UTC Cristian Gafton <gafton@amazon.com>
- added submodule prep for package kbd
